<template>
  <div class="row fullwidth" style="height: 48vh">
    <!-- <q-scroll-area> -->
    <q-virtual-scroll
      style="max-height: 100%;"
      :items="eventDays"
      separator
      :class="$q.screen.xs ? 'col-12' : 'col-10 offset-1'"
    >
      <template v-slot="{ item, index }">
        <q-item :key="index">
          <q-card flat style="width: 100%">
            <q-card-section horizontal>
              <q-card-section class="col-2">
                <div class="text-bold">
                  {{ item.day }}
                </div>
              </q-card-section>
              <q-card-section class="col-10">
                <events :events="item.events" v-if="item.events"></events>
                <q-btn
                  size="sm"
                  no-caps
                  outline
                  label="Add event"
                  :to="`/new/${item.day}`"
                  v-if="item.day === selected"
                />
              </q-card-section>
            </q-card-section>
          </q-card>
        </q-item>
      </template>
    </q-virtual-scroll>
  </div>
</template>

<script>
import { mapState } from "vuex";
import dayjs from "dayjs";
import Events from "components/Events";

export default {
  name: "EventList",
  props: ["selected"],
  components: {
    Events
  },
  data() {
    return {
      eventDays: []
    };
  },
  computed: {
    ...mapState(["days"])
  },
  mounted() {
    console.log("days array: ", Array.from(this.days));
    console.log("days obj: ", this.days);
    this.eventDays = this.days.concat([{day: this.selected, events: []}])
  },
  methods: {
    listDate(key) {
      return dayjs(key).format("ddd, MMMM D");
    },
    handleDayClick(e) {
      console.log("day clicked: ", e);
      this.date = e.date;
      // scroll event list to selected day
      this.selected = e.date;
      if (this.notes[this.date]) {
        // we have an existing note
        this.note = this.notes[this.date];
        this.editorReadOnly = true;
      }
      this.noteTitle = dayjs(e.date).format("ddd, MMMM D");
      this.editing = true;
    }
  }
};
</script>

<style></style>
